Name: egcs-ucr
Summary: C/C++ cross compiler tools
# The version tracks the GNU version that the package is based on,
# and the release tracks the patch releases.
Version: 1.0
# Release 2 --
#   Add the files in /usr/local/targetdir/*
Release: 2

Copyright: GPL
Group: Development/Languages
Vendor: Picture Elements, Inc.
Packager: Stephen Williams <steve@picturel.com>
Source0: ftp://ftp.cygnus.com/pub/egcs/releases/egcs-1.0/egcs-core-1.0.tar.gz
Source1: ftp://ftp.cygnus.com/pub/egcs/releases/egcs-1.0/egcs-g++-1.0.tar.gz
Patch0: egcs-ucr.diff

%description
This contains the source to make the various cross compilers for the
targets that uCR supports. This source package contains a collection
of targets.

%package -n egcs-i960-ucr
Summary: C/C++ tools for i960-ucr
Group: Development/Languages
Requires: binutils-i960-ucr
%description -n egcs-i960-ucr
This is the C/C++ compiler suite for the i960-ucr target. The compiler
is from the EGCS project hosted by Cygnus Solutions.

%package -n egcs-arm-ucr
Summary: C/C++ tools for arm-ucr
Group: Development/Languages
Requires: binutils-arm-ucr
%description -n egcs-arm-ucr
This is the C/C++ compiler suite for the arm-ucr target. The compiler
is from the EGCS project hosted by Cygnus Solutions.

%package -n egcs-m68k-ucr
Summary: C/C++ tools for m68k-ucr
Group: Development/Languages
Requires: binutils-m68k-ucr
%description -n egcs-m68k-ucr
This is the C/C++ compiler suite for the m68k-ucr target. The compiler
is from the EGCS project hosted by Cygnus Solutions.


%prep
%setup -c -n egcs-ucr -a 1
cd egcs-$RPM_PACKAGE_VERSION
%patch0 -p1


%build

#
#  Build for the i960 target...
#
mkdir i960-ucr
cd i960-ucr
$RPM_BUILD_DIR/egcs-ucr/egcs-$RPM_PACKAGE_VERSION/gcc/configure --target=i960-ucr --prefix=/usr/local
make CFLAGS=-O2 LDFLAGS=-s
cd ..

#
#  Build for the arm target...
#
mkdir arm-ucr
cd arm-ucr
$RPM_BUILD_DIR/egcs-ucr/egcs-$RPM_PACKAGE_VERSION/gcc/configure --target=arm-ucr --prefix=/usr/local
make CFLAGS=-O2 LDFLAGS=-s
cd ..

#
#  Build for the m68k target...
#
mkdir m68k-ucr
cd m68k-ucr
$RPM_BUILD_DIR/egcs-ucr/egcs-$RPM_PACKAGE_VERSION/gcc/configure --target=m68k-ucr --prefix=/usr/local
make CFLAGS=-O2 LDFLAGS=-s
cd ..


%install
(cd i960-ucr ; make install)
(cd arm-ucr ; make install)
(cd m68k-ucr ; make install)

%clean
rm -rf egcs-ucr

%files -n egcs-i960-ucr
%doc egcs-1.0/gcc/NEWS
%docdir /usr/local/man
%docdir /usr/local/info

/usr/local/i960-ucr/bin/gcc
/usr/local/bin/i960-ucr-gcc
/usr/local/bin/i960-ucr-c++
/usr/local/bin/i960-ucr-g++
/usr/local/lib/gcc-lib/i960-ucr/egcs-2.90.21


%files -n egcs-arm-ucr
%doc egcs-1.0/gcc/NEWS
%docdir /usr/local/man
%docdir /usr/local/info

/usr/local/arm-ucr/bin/gcc
/usr/local/bin/arm-ucr-gcc
/usr/local/bin/arm-ucr-c++
/usr/local/bin/arm-ucr-g++
/usr/local/lib/gcc-lib/arm-ucr/egcs-2.90.21


%files -n egcs-m68k-ucr
%doc egcs-1.0/gcc/NEWS
%docdir /usr/local/man
%docdir /usr/local/info

/usr/local/m68k-ucr/bin/gcc
/usr/local/bin/m68k-ucr-gcc
/usr/local/bin/m68k-ucr-c++
/usr/local/bin/m68k-ucr-g++
/usr/local/lib/gcc-lib/m68k-ucr/egcs-2.90.21
