#ifndef __ucr_param_H
#define __ucr_param_H
/*
 * Copyright (c) 1996 Picture Elements, Inc.
 *    Stephen Williams
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    Library General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc.,
 *    59 Temple Place - Suite 330
 *    Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc.,
 *    777 Panoramic Way
 *    Berkeley, CA 94704.
 */
#ident "$Id: param.h,v 1.7 1998/04/03 01:30:51 steve Exp $"
/*
 * $Log: param.h,v $
 * Revision 1.7  1998/04/03 01:30:51  steve
 *  More ISR per exception.
 *
 * Revision 1.6  1998/01/24 01:09:30  picturel
 *  ISE shared interrupts on the PCI bus.
 *
 * Revision 1.5  1997/04/30 16:53:14  steve
 *  Add initial interrupt support to BIOS32,
 *  add some more ISO C library functions to ucr.
 *
 * Revision 1.4  1996/11/07 02:30:46  steve
 *  fix includion protection.
 *
 * Revision 1.3  1996/10/28 03:45:02  steve
 *  License notice.
 *
 * Revision 1.2  1996/10/04 23:34:23  steve
 *  Add a BUS driver for the ISE board.
 *
 * Revision 1.1  1996/09/19 04:43:49  steve
 *  Add the i960_ise target, change the target
 *  configuration headers to allow sharing by
 *  targets, fix up the make clean rule.
 *
 */

/*
 * The ISE boards run the i960 in dedicated mode, and support 8
 * external sources and 2 timer interrupts. Thus, only 10 possible
 * values can be passed to set_isr. Those in turn have meanings
 * assigned by Picture Elements.
 */
# define MAX_EXCEPTION 10


/*
 * The locore-i960_ise.s file assigns vector numbers as described in
 * the following defines. The actual numbers placed in the IMAP
 * registers are 6 more then these numbers, but uCR_isr-i960.s
 * subtracts 6 from the vector number to get these codes again.
 */

# define XINT7 7
# define XINT6 6
# define XINT5 5
# define XINT4 4
# define XINT3 3
# define XINT2 2
# define XINT1 1
# define XINT0 0


/*
 * Since the numbers are preassigned to hardware 1-to-1, there is no
 * need to support more then one ISR per interrupt.
 */
# define MAX_ISR_PER_EXCEPTION 4

#endif
