#ifndef __gdb_debug_H
#define __gdb_debug_H
/*
 * Copyright (c) 1996 Picture Elements, Inc.
 *    Stephen Williams
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    Library General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc.,
 *    59 Temple Place - Suite 330
 *    Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc.,
 *    777 Panoramic Way
 *    Berkeley, CA 94704.
 */
#ident "$Id: debug.h,v 1.3 1996/10/31 00:40:40 steve Exp $"
/*
 * $Log: debug.h,v $
 * Revision 1.3  1996/10/31 00:40:40  steve
 *  Add pause for explicit breakpoints.
 *
 * Revision 1.2  1996/10/24 00:06:22  steve
 *  Target specific debugging support.
 *
 * Revision 1.1  1996/10/22 03:58:43  steve
 *  Create a debug.h header for debugger tools other then
 *  the GDB class itself, and create a gdb_thread function
 *  to start a GDB thread.
 *
 */

class BUS;

# include  <gdb/debug_asm.h>

/*
 * This function starts a thread with a GDB running in it. It does all
 * the dirty work of allocating a stack and creating a GDB object.
 */

extern void gdb_thread(BUS*bus);

/*
 * This function gives the debugger a chance to interact with the
 * thread before allowing it to continue. It calls GDB::pause() for
 * the gdb created by the above function.
 */
extern void gdb_pause();

#endif
