#ifndef __i960_i960Rx_H
#define __i960_i960Rx_H

/*
 * Copyright (c) 1995 Picture Elements Inc.
 *	Stephen Williams
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    Library General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc.,
 *    59 Temple Place - Suite 330
 *    Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc.,
 *    777 Panoramic Way
 *    Berkeley, CA 94704.
 */
#ident "$Id: i960Rx.h,v 1.5 1998/06/04 16:44:26 steve Exp $"
/*
 * $Log: i960Rx.h,v $
 * Revision 1.5  1998/06/04 16:44:26  steve
 *  more registers.
 *
 * Revision 1.4  1997/11/03 23:25:40  steve
 *  Support PCI bus reset on command.
 *
 * Revision 1.3  1997/08/27 04:48:52  steve
 *  Move PCI IO to i960Rx.
 *
 * Revision 1.2  1997/08/02 04:29:00  steve
 *  Some standard constants.
 *
 * Revision 1.1  1997/06/15 20:03:53  steve
 *  Add i960Rx definitions.
 *
 */

/*
 * This file lists the fixed register that are contained within the
 * i960Rx series of processors. Each symbol defined here is an
 * l-value, although it may be defined as a constant if
 * appropriate. As much as possible, I use names defined in the
 * i960RP Microprocessor User's Manual. 
 */

#define SBNR   (*(unsigned char*)0x1019)
#define BCR    (*(volatile unsigned short*)0x103E)
#define PIRSR  (*(unsigned long*)0x1050)
#define PIALR  (*(unsigned long*)0x1240)
#define PIATVR (*(unsigned long*)0x1244)

#define IPND   (*(volatile unsigned long*)0xff008500)
#define IMSK   (*(volatile unsigned long*)0xff008504)

/*
 * These functions access the I/O space of the secondary PCI bus
 * through the IO translation window. They assume that the translate
 * value is set to zero, so the port address does not need to be
 * modified. This conforms with how the BIOS32 class sets up the region.
 */
extern inline unsigned char s_inb(unsigned port)
{ return *(unsigned char*)(0x90010000 + port); }

extern inline unsigned short s_inw(unsigned port)
{ return *(unsigned short*)(0x90010000 + port); }

extern inline unsigned long s_inl(unsigned port)
{ return *(unsigned long*)(0x90010000 + port); }

extern inline void s_outb(unsigned char val, unsigned port)
{ *(unsigned char*)(0x90010000 + port) = val; }

extern inline void s_outw(unsigned short val, unsigned port)
{ *(unsigned short*)(0x90010000 + port) = val; }

extern inline void s_outl(unsigned long val, unsigned port)
{ *(unsigned long*)(0x90010000 + port) = val; }

#endif
