#ifndef __m68k_ucr_asm_H
#define __m68k_ucr_asm_H
/*
 * Copyright (c) 1997 Picture Elements, Inc.
 *    Stephen Williams
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    Library General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc.,
 *    59 Temple Place - Suite 330
 *    Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc.,
 *    777 Panoramic Way
 *    Berkeley, CA 94704.
 */
#ident "$Id: ucr_asm.h,v 1.1 1997/02/21 21:43:19 steve Exp $"
/*
 * $Log: ucr_asm.h,v $
 * Revision 1.1  1997/02/21 21:43:19  steve
 *  Update m68k support for newer config structure.
 *
 */

/* NOTE:
 * You should be getting at this header file by including
 *	<ucr/config.h>
 * This is a header file put in the target specific include directory
 * and includes the header for the right CPU type, like this one if
 * you are using an m68k.
 */

/* NOTE:
 * This header file may be included by C or C++ alike. I need to make
 * sure things are parseable by either when implementing this.
 */


#if defined(__cplusplus)
extern "C" {
#endif

/*
 * The spl cookie has the bits of the statuc register, the interrupt
 * priority bits are of immediate interest to us.
 */
typedef unsigned short spl_cookie_t;

inline int isr_hot_flag()
{
      extern long uCR_isr_hot_flag;
      return uCR_isr_hot_flag;
}

extern spl_cookie_t thread_splhi();

extern spl_cookie_t thread_spl(spl_cookie_t cookie);

extern void thread_spl_low();

#if defined(__cplusplus)
}
#endif



#endif
