#ifndef __math_H
#define __math_H
/*
 * Copyright (c) 1996 Picture Elements, Inc.
 *    Stephen Williams
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    Library General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc.,
 *    59 Temple Place - Suite 330
 *    Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc.,
 *    777 Panoramic Way
 *    Berkeley, CA 94704.
 */
#ident "$Id: math.h,v 1.3 1996/10/28 03:45:09 steve Exp $"
/*
 * $Log: math.h,v $
 * Revision 1.3  1996/10/28 03:45:09  steve
 *  License notice.
 *
 * Revision 1.2  1996/10/23 00:16:43  steve
 *  Make suitable for inclusion in C++ source.
 *
 * Revision 1.1  1996/09/17 22:23:00  steve
 *  Add a math library.
 *
 */

#ifdef __cplusplus
extern "C" {
#endif

struct exception {
	int type;
	char *name;
	double arg1;
	double arg2;
	double retval;
};

extern double acos (double) __attribute__ ((const));
extern double asin (double) __attribute__ ((const));
extern double atan (double) __attribute__ ((const));
extern double atan2 (double, double) __attribute__ ((const));
extern double cos (double) __attribute__ ((const));
extern double sin (double) __attribute__ ((const));
extern double tan (double) __attribute__ ((const));

extern double cosh (double) __attribute__ ((const));
extern double sinh (double) __attribute__ ((const));
extern double tanh (double) __attribute__ ((const));

extern double exp (double) __attribute__ ((const));
extern double frexp (double, int *);
extern double ldexp (double, int) __attribute__ ((const));
extern double log (double) __attribute__ ((const));
extern double log10 (double) __attribute__ ((const));
extern double modf (double, double *);

extern double pow (double, double) __attribute__ ((const));
extern double sqrt (double) __attribute__ ((const));

extern double ceil (double) __attribute__ ((const));
extern double fabs (double) __attribute__ ((const));
extern double floor (double) __attribute__ ((const));
extern double fmod (double, double) __attribute__ ((const));

extern double erf (double) __attribute__ ((const));
extern double erfc (double) __attribute__ ((const));
extern double gamma (double) __attribute__ ((const));
extern double hypot (double, double) __attribute__ ((const));
extern int isnan (double) __attribute__ ((const));
extern int finite (double) __attribute__ ((const));
extern double j0 (double) __attribute__ ((const));
extern double j1 (double) __attribute__ ((const));
extern double jn (int, double) __attribute__ ((const));
extern double lgamma (double) __attribute__ ((const));
extern double y0 (double) __attribute__ ((const));
extern double y1 (double) __attribute__ ((const));
extern double yn (int, double) __attribute__ ((const));

extern double acosh (double) __attribute__ ((const));
extern double asinh (double) __attribute__ ((const));
extern double atanh (double) __attribute__ ((const));
extern double cbrt (double) __attribute__ ((const));
extern double logb (double) __attribute__ ((const));
extern double nextafter (double, double) __attribute__ ((const));
extern double remainder (double, double) __attribute__ ((const));
extern double scalb (double, double) __attribute__ ((const));

extern int matherr (struct exception *);

#ifdef __cplusplus
};
#endif

#endif
