#ifndef __setjmp_H
#define __setjmp_H
/*
 * Copyright (c) 1996 Picture Elements, Inc.
 *    Stephen Williams
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    Library General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc.,
 *    59 Temple Place - Suite 330
 *    Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc.,
 *    777 Panoramic Way
 *    Berkeley, CA 94704.
 */
#ident "$Id: setjmp.h,v 1.1 1996/10/29 01:31:28 steve Exp $"
/*
 * $Log: setjmp.h,v $
 * Revision 1.1  1996/10/29 01:31:28  steve
 *  Implement the setjmp and longjmp routines
 *  for the i960 and add them in the documentation.
 *
 */

/*
 * This header file contains declaration required by the standard
 * ANSI/ISO 9899-1990 Programming Languages - C
 * Section 7.6 Nonlocal jumps
 */

/*
 * Implementations of this are particularly icky, as there is really
 * no C way to do this. Assembly code is required. Fortunately, once
 * that concession is made the resulting assembly code is not too
 * terrible, certainly nothing like real thread-switch code.
 *
 * setjmp/longjmp are icky even independent of the implementation
 * because there are opportunities here to make a royal mess. However,
 * some code (not in uCR, thank goodness) uses these so I provide them
 * here for your debugger's amusement.
 *
 * NOTE carefully that setjmp/longjmp are not at all suitable for
 * anything like thread switching because the longjmp is only allowed
 * to unwind the stack. It can jump out of frames, but not into others.
 */

# include  <setjmp_asm.h>

#ifdef __cplusplus
extern "C" {
#endif

extern int setjmp(jmp_buf env);

extern void longjmp(jmp_buf env, int val) __attribute__ ((noreturn));

#ifdef __cplusplus
};
#endif

#endif
