#ifndef __udlfcn_H
#define __udlfcn_H
/*
 * Copyright (c) 1997 Picture Elements, Inc.
 *    Stephen Williams (steve@picturel.com)
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *  ---
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc., 777 Panoramic Way, Berkeley, CA 94704.

 */
#ident "$Id: udlfcn.h,v 1.2 1997/09/04 01:05:44 steve Exp $"

/*
 * The udl functions support run-time linking of modules in the uCR
 * world.
 */

# include  <chips/BUS.h>

class BUS::Channel;
struct udl_handle;

/*
 * The udlopen function listens on the channel for requests on the
 * channel passed. It continues to listen to the channel, answering
 * link requests, until it completely receives and initializes a
 * module downloaded from the host. The result, then, is an opaque
 * handle that can be used to refer to the loaded module.
 */
extern udl_handle* udlopen(BUS::Channel&chan);

/*
 * When the application no longer needs the module, it may close it,
 * causing destructors to be implicitly called and the static memory
 * of the module to be released.
 */
extern void udlclose(udl_handle*);

extern void*udlsym(udl_handle*, const char*name);

/*
 * $Log: udlfcn.h,v $
 * Revision 1.2  1997/09/04 01:05:44  steve
 *  Add the udlsym function.
 *
 * Revision 1.1  1997/09/03 23:45:02  steve
 *  Add support for dynamic loading, including the
 *  commands to make symbol tables, read and link
 *  modules, and download fondled binaries.
 *
 */


#endif
