
#
# Copyright (c) 1995 Picture Elements Inc.
#	Stephen Williams
#
#    This source code is free software; you can redistribute it
#    and/or modify it in source code form under the terms of the GNU
#    Library General Public License as published by the Free Software
#    Foundation; either version 2 of the License, or (at your option)
#    any later version. In order to redistribute the software in
#    binary form, you will need a Picture Elements Binary Software
#    License.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Library General Public License for more details.
#
#    You should have received a copy of the GNU Library General Public
#    License along with this program; if not, write to the Free
#    Software Foundation, Inc.,
#    59 Temple Place - Suite 330
#    Boston, MA 02111-1307, USA
#
#    You should also have recieved a copy of the Picture Elements
#    Binary Software License offer along with the source. This offer
#    allows you to obtain the right to redistribute the software in
#    binary (compiled) form. If you have not received it, contact
#    Picture Elements, Inc.,
#    777 Panoramic Way
#    Berkeley, CA 94704.
#
#ident "$Id: program.mk,v 1.3 1996/10/28 03:45:33 steve Exp $"
#
# $Log: program.mk,v $
# Revision 1.3  1996/10/28 03:45:33  steve
#  License notice.
#
# Revision 1.2  1996/09/19 04:44:00  steve
#  Add the i960_ise target, change the target
#  configuration headers to allow sharing by
#  targets, fix up the make clean rule.
#
# Revision 1.1  1995/09/11 01:05:10  steve
#  Make programs, dofferent from images.
#
#

#
# This is different form image.mk in that it makes a program, not a ROM image.
#
# This assumes that $(UCR)/make/rules.mk has been included, and the
# following macros filled in:
#
#	TARG	-- This is the target binary. Should be foo.bin.
#
#	OBJ	-- This is a list of object files. This makefile will
#		   automatically prepend any subdirs, etc.
#
#	LIBS	-- Libraries in the form -lfoo. Do not include -lucr,
#		   as it will automatically be included.
#

all: $(TARG)

OBJ- := $(patsubst %, $(OBJD)/%, $(OBJ))
TARG- := $(patsubst %.bin, %, $(TARG))

$(TARG): $(OBJ-) $(shell $(UCR)/make/findlibs.sh $(LIBR) $(LIBS))
	$(CXX) $(LDFLAGS) $(LIBR) -o $(TARG)  $(OBJ-) $(LIBS)


clean::
	rm -f $(OBJ-) $(TARG-)
	rm -f $(patsubst %.o, %.d, $(OBJ-))

ifndef NODEP
-include $(patsubst %.o, %.d, $(OBJ-))
endif
