
/*
 * Copyright (c) 1995 Picture Elements Inc.
 *	Stephen Williams
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    Library General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc.,
 *    59 Temple Place - Suite 330
 *    Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc.,
 *    777 Panoramic Way
 *    Berkeley, CA 94704.
 */
#ident "$Id: Band.cc,v 1.3 1996/10/28 03:45:48 steve Exp $"
/*
 * $Log: Band.cc,v $
 * Revision 1.3  1996/10/28 03:45:48  steve
 *  License notice.
 *
 * Revision 1.2  1995/10/17 18:29:04  steve
 *  Put in the band queue class help for
 *  doing queue synchronization.
 *
 * Revision 1.1  1995/09/02 18:27:18  steve
 *  Initial import of UCR core to cvs.
 *
 *
 */

# include  <mc68322/Band.h>
# include  <assert.h>

bool BandQueue::not_empty(const BandQueue*q)
{ return q->count_ > 0; }

BandQueue::BandQueue()
: last_(0), count_(0)
{ }


void BandQueue::enqueue(Band*band)
{
      assert( band->next_ == 0 );
      count_ += 1;

      if (last_ == 0) {
	    band->next_ = band;
      } else {
	    band->next_  = last_->next_;
	    last_->next_ = band;
      }
      last_ = band;
}

Band* BandQueue::peek() const
{
      return last_? last_->next_ : 0;
}

Band* BandQueue::pull()
{
      if (last_ == 0) return 0;

      count_ -= 1;
      Band*cur = last_->next_;

      last_->next_ = cur->next_;
      if (last_ == cur) last_ = 0;

      cur->next_ = 0;
      return cur;
}
