
/*
 * Copyright (c) 1995 Picture Elements Inc.
 *	Stephen Williams
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    Library General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc.,
 *    59 Temple Place - Suite 330
 *    Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc.,
 *    777 Panoramic Way
 *    Berkeley, CA 94704.
 */
#ident "$Id: External.cc,v 1.2 1996/10/28 03:45:49 steve Exp $"
/*
 * $Log: External.cc,v $
 * Revision 1.2  1996/10/28 03:45:49  steve
 *  License notice.
 *
 * Revision 1.1  1995/10/04 23:17:54  steve
 *  Add the External class.
 *
 */


# include  <mc68322/External.h>

External::External(unsigned which, unsigned short level, Polarity mode,
	       unsigned long base)
: enable_nest_(0), regs_( (REGS_*) (base + 0x770 + which*0x10) )
{
      regs_->level = level;
      regs_->mode = mode;
}

void External::enable()
{
      enable_nest_ += 1;
      if (enable_nest_ == 1) regs_->enable = 1;
}

void External::disable()
{
      enable_nest_ -= 1;
      if (enable_nest_ == 0) regs_->enable = 0;
}

void External::clear_interrupt()
{
      regs_->status = 1;
}

unsigned short External::level() const
{
      return regs_->level & 0x7;
}
