/*
 * Copyright (c) 1996 Picture Elements, Inc.
 *    Stephen Williams
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    Library General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc.,
 *    59 Temple Place - Suite 330
 *    Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc.,
 *    777 Panoramic Way
 *    Berkeley, CA 94704.
 */
#ident "$Id: ILock.cc,v 1.5 1998/01/01 20:45:16 steve Exp $"
/*
 * $Log: ILock.cc,v $
 * Revision 1.5  1998/01/01 20:45:16  steve
 *  ISync has const methods.
 *
 * Revision 1.4  1997/02/17 21:49:01  steve
 *  reinterpret cast where 2.7.2 was too generous.
 *
 * Revision 1.3  1996/10/28 03:46:06  steve
 *  License notice.
 *
 * Revision 1.2  1996/07/30 03:12:45  steve
 *  Fix broken test_and_set function.
 *
 * Revision 1.1  1996/07/23 23:59:37  steve
 *  Add the ILock class
 *
 */

# include  <ucr/ILock.h>
# include  <assert.h>

/*
 * This test function will return true for only one thread. If one
 * thread is released, then the flag is turned off and the lock is
 * automatically grabbed.
 */
static bool test_and_set(volatile bool*flag)
{
      if (*flag == false) { return false; }
      *flag = false;
      return true;
}

ILock::ILock(bool f)
: flag_(f)
{
}

ILock::~ILock()
{
}

void ILock::get()
{
      sleep(reinterpret_cast<ISync::funp>(test_and_set), &flag_);
}

void ILock::put()
{
      assert( !flag_ );
      flag_ = true;
      wakeup();
}

void ILock::wait()
{
      sleep(&flag_);
}
