
/*
 * Copyright (c) 1995 Picture Elements Inc.
 *	Stephen Williams
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    Library General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc.,
 *    59 Temple Place - Suite 330
 *    Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc.,
 *    777 Panoramic Way
 *    Berkeley, CA 94704.
 */
#ident "$Id: ISync_mask.cc,v 1.6 1998/01/01 20:45:17 steve Exp $"
/*
 * $Log: ISync_mask.cc,v $
 * Revision 1.6  1998/01/01 20:45:17  steve
 *  ISync has const methods.
 *
 * Revision 1.5  1997/02/17 21:49:02  steve
 *  reinterpret cast where 2.7.2 was too generous.
 *
 * Revision 1.4  1996/10/28 03:46:09  steve
 *  License notice.
 *
 * Revision 1.3  1995/10/20 04:00:19  steve
 *  Neatness.
 *
 * Revision 1.2  1995/10/15 21:54:32  steve
 *  The sleep that understands bit masks now
 *  handles on and off tests, with don't care bits.
 *
 * Revision 1.1  1995/10/15 05:27:33  steve
 *  Add a sleep that understands bit masks, and
 *  split up the ISync.cc source file.
 *
 */

# include  <ucr/ISync.h>


struct PtrAndMask {
      const volatile unsigned short*word;
      unsigned short on_mask, off_mask;
};

/*
 * This rather nasty looking expression tests that the on_bits are on
 * and the off_bits are off in the word. Return true if the pattern is
 * as desired, and false otherwise.
 */
static bool test_mask(PtrAndMask*arg)
{
      unsigned short word = *arg->word;
      return ((word & arg->on_mask) | (~word & arg->off_mask)) ==
	(arg->on_mask | arg->off_mask);
}

void ISync::sleep(const volatile unsigned short&word,
		  unsigned short on_mask,
		  unsigned short off_mask)
{
      PtrAndMask arg;
      arg.word = &word;
      arg.on_mask = on_mask;
      arg.off_mask = off_mask;
      sleep(reinterpret_cast<bool (*)(const volatile void *)>(::test_mask), &arg);
}
