

#
# Copyright (c) 1995 Picture Elements Inc.
#	Stephen Williams
#
#    This source code is free software; you can redistribute it
#    and/or modify it in source code form under the terms of the GNU
#    Library General Public License as published by the Free Software
#    Foundation; either version 2 of the License, or (at your option)
#    any later version. In order to redistribute the software in
#    binary form, you will need a Picture Elements Binary Software
#    License.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Library General Public License for more details.
#
#    You should have received a copy of the GNU Library General Public
#    License along with this program; if not, write to the Free
#    Software Foundation, Inc.,
#    59 Temple Place - Suite 330
#    Boston, MA 02111-1307, USA
#
#    You should also have recieved a copy of the Picture Elements
#    Binary Software License offer along with the source. This offer
#    allows you to obtain the right to redistribute the software in
#    binary (compiled) form. If you have not received it, contact
#    Picture Elements, Inc.,
#    777 Panoramic Way
#    Berkeley, CA 94704.
#
.ident "$Id: misc-m68k_coff.s,v 1.5 1996/10/28 03:46:31 steve Exp $"
#
# $Log: misc-m68k_coff.s,v $
# Revision 1.5  1996/10/28 03:46:31  steve
#  License notice.
#
# Revision 1.4  1996/08/01 17:03:29  steve
#  Split _exit into its own file.
#
# Revision 1.3  1996/05/29 04:29:39  steve
#  Portable way to ENABLE interrupts.
#
# Revision 1.2  1996/05/27 22:45:27  steve
#  Make exit(int) that matches standard.
#
# Revision 1.1  1996/05/24 01:46:50  steve
#  Initial port to i960_cyclone
#  Seperate some files in the library to seperate files
#  for making smaller binaries, use uCR_ prefix for private
#  symbols, move assembly files around for compile-time
#  portability, change __start to ucr_start and give it
#  new behavior, and simplify the ucr_assert implementation.
#
# Revision 1.2  1995/12/07 01:47:57  steve
#  Add support for Netrom debugger hooks,
#  Add support for GDB using the netrom.
#
# Revision 1.1  1995/09/02 18:27:31  steve
#  Initial import of UCR core to cvs.
#
#


 | thread_splhi sets the status register to reflect the highest
 | possible priority, then returns the old value. That value can be
 | passed to thread_spl(x) to restore the priority level.
 |
 |	unsigned short thread_splhi();
 |	unsigned short thread_spl(unsigned short); 
 |
 | thread_pause() suspends the CPU until an interrupt of some type
 | awakens it. The thread scheduler mses this to wait for an exception
 | to maybe make a thread runnable.
 |
 | _exit(int) doesn't mean anything here, so just treat it as abort.
 | I only put it here because some libgcc.a routines call it.
	
	.global thread_splhi
thread_splhi:
	move	%sr,%d0
	ori	#0x0700,%sr
	rts

	.global	thread_spl_low
thread_spl_low:
	andi	#0xf800,%sr
	rts

	.global thread_spl
thread_spl:
	move	%sr,%d0
	move	6(%sp),%sr
	rts

	.global thread_pause
thread_pause:
	move	%sr,-(%sp)
	stop	#0x2000
	move	(%sp)+,%sr
	rts
