
#
# Copyright (c) 1996 Picture Elements Inc.
#	Stephen Williams
#
#    This source code is free software; you can redistribute it
#    and/or modify it in source code form under the terms of the GNU
#    Library General Public License as published by the Free Software
#    Foundation; either version 2 of the License, or (at your option)
#    any later version. In order to redistribute the software in
#    binary form, you will need a Picture Elements Binary Software
#    License.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Library General Public License for more details.
#
#    You should have received a copy of the GNU Library General Public
#    License along with this program; if not, write to the Free
#    Software Foundation, Inc.,
#    59 Temple Place - Suite 330
#    Boston, MA 02111-1307, USA
#
#    You should also have recieved a copy of the Picture Elements
#    Binary Software License offer along with the source. This offer
#    allows you to obtain the right to redistribute the software in
#    binary (compiled) form. If you have not received it, contact
#    Picture Elements, Inc.,
#    777 Panoramic Way
#    Berkeley, CA 94704.
#
.ident "$Id: pause-i960Jx.s,v 1.2 1996/10/28 03:46:32 steve Exp $"
#
# $Log: pause-i960Jx.s,v $
# Revision 1.2  1996/10/28 03:46:32  steve
#  License notice.
#
# Revision 1.1  1996/10/25 06:32:01  steve
#  Add a more efficient Jx implementation of
#  thread_pause, and seperate pause into its
#  own source files.
#
#

# This implementation of the thread_pause function is the most efficient
# possible for the i960Jx. It makes use of the halt instruction, that only
# exists on Jx series CPUs. However, some boards that have I960Jx CPUs
# on them don't properly handle the HALT bus behavior. I960RP targets do
# not have that problem because halt mode doesn't affect anything external.

	.file	"pause-i960Jx.s"
	.text
	.global _thread_pause
_thread_pause:
	shlo	16, 0x1f, r4	# ldconst 0x001f0000, r4
	mov	0, r5		# ldconst 0x00000000, r5
	
	intdis
	modpc	r4, r4, r5
	halt	1
	modpc	r4, r4, r5
	inten
	ret
