
#
# Copyright (c) 1996 Picture Elements Inc.
#	Stephen Williams (steve@picturel.com)
#
#    This source code is free software; you can redistribute it
#    and/or modify it in source code form under the terms of the GNU
#    Library General Public License as published by the Free Software
#    Foundation; either version 2 of the License, or (at your option)
#    any later version. In order to redistribute the software in
#    binary form, you will need a Picture Elements Binary Software
#    License.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Library General Public License for more details.
#
#    You should have received a copy of the GNU Library General Public
#    License along with this program; if not, write to the Free
#    Software Foundation, Inc.,
#    59 Temple Place - Suite 330
#    Boston, MA 02111-1307, USA
#
#    You should also have recieved a copy of the Picture Elements
#    Binary Software License offer along with the source. This offer
#    allows you to obtain the right to redistribute the software in
#    binary (compiled) form. If you have not received it, contact
#    Picture Elements, Inc.,
#    777 Panoramic Way
#    Berkeley, CA 94704.
#
.ident "$Id: setjmp-i386.s,v 1.1 1996/11/10 19:29:09 steve Exp $"
#
# $Log: setjmp-i386.s,v $
# Revision 1.1  1996/11/10 19:29:09  steve
#  Add setjmp and longjmp for the i386,
#  Add support for linux system calls on i386,
#  and add a LinuxIO device driver.
#
#

	.file "setjmp-i386.s"
	.text

# This function stores the necessary context in the jmp_buf and returns
# a 0. The context is enough for longjmp to cause a return to the point
# where this was called, with a return code other then 0.

# The call to the setjmp takes a single parameter which I use to store
# enough context for the longjmp to restore this frame. i do NOT need to
# save everything, but I do need to save the return instruction pointer
# from the stack so that the longjmp can use it. The stack frame on entry
# to setjmp is:
#
#	|     |
#	+-----+
#	| env |
#	+-----+
#	| RIP |  <-- %esp
#	+-----+
#
# The longjmp must recreate this stack with the saved RIP and %esp register.
#

# extern int setjmp(jmp_buf env)

	.global setjmp
setjmp:

	movl	4(%esp), %eax
	movl	0(%esp), %edx

	movl	%edx, 0(%eax)
	movl	%esp, 4(%eax)
	movl	%ebp, 8(%eax)
	
  # return 0
	xorl	%eax, %eax
	ret


# The longjmp function takes an environment stored by a previous setjmp
# and uses it to restore the register context that the setjmp came from.
# By also restoring the pfp, the longjmp also restores the stack position
# and rip. This causes a ret from here to appear as a return from the
# setjmp. (That is why the longjmp can never return.)

# extern void longjmp(jmp_buf env, int val) __attribute__((noreturn))

	.global	longjmp
longjmp:

	movl	8(%esp), %eax	# val
	movl	4(%esp), %edx	# env

  # Get the saved return pointer, and the saved stack pointers, from the
  # jmp_buf pointed to by env.

	movl	0(%edx), %ecx

	movl	4(%edx), %esp
	movl	8(%edx), %ebp

  # Build up enough stack frame to return. The return code is already in
  # %eax, make sure it is not 0. Place the return address on the stack and
  # return with the adjusted return code.

	testl	%eax, %eax
	jnz	0f
	movl	$1, %eax
0:

	movl	%ecx, 0(%esp)
	ret
