#ifndef __thread_cookie_H
#define __thread_cookie_H
/*
 * Copyright (c) 1996 Picture Elements, Inc.
 *    Stephen Williams
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    Library General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc.,
 *    59 Temple Place - Suite 330
 *    Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc.,
 *    777 Panoramic Way
 *    Berkeley, CA 94704.
 */
#ident "$Id: thread_cookie-m68k.h,v 1.3 1997/02/21 21:43:25 steve Exp $"
/*
 * $Log: thread_cookie-m68k.h,v $
 * Revision 1.3  1997/02/21 21:43:25  steve
 *  Update m68k support for newer config structure.
 *
 * Revision 1.2  1996/10/28 03:46:40  steve
 *  License notice.
 *
 * Revision 1.1  1996/05/27 22:50:02  steve
 *  implement thread_create and thread_switch for the i960,
 *  rename some __foo symbols to uCR_foo for neatness.
 *
 */

/*
 * This structure describes the thread context save area for the m68k
 * CPU types. The uCR_switch-m68k_coff.s source file expects these
 * values to be arranged in a certain way.
 */

# define REGISTER_COUNT 16
# define REGISTER_SP 15


struct ThreadCookie {
      unsigned long regs[REGISTER_COUNT];
      unsigned short sreg;
};

# define COOKIE_INITIALIZER { { 0 }, 0x2000 }

static inline void thread_cookie_init(ThreadCookie*cookie)
{
      cookie->sreg = 0x2000;
      for (unsigned idx = 0 ;  idx < REGISTER_COUNT ;  idx += 1)
	    cookie->regs[idx] = 0;
}


#endif
