
/*
 * Copyright (c) 1995 Picture Elements Inc.
 *	Stephen Williams
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    Library General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc.,
 *    59 Temple Place - Suite 330
 *    Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc.,
 *    777 Panoramic Way
 *    Berkeley, CA 94704.
 */
#ident "$Id: thread_self_test.cc,v 1.7 1997/08/26 19:27:05 steve Exp $"
/*
 * $Log: thread_self_test.cc,v $
 * Revision 1.7  1997/08/26 19:27:05  steve
 *  Stack checks cannot occur everywhere because the
 *  ISR stack may be outside the stack proper.
 *
 * Revision 1.6  1997/02/21 21:43:25  steve
 *  Update m68k support for newer config structure.
 *
 * Revision 1.5  1996/10/28 03:46:43  steve
 *  License notice.
 *
 * Revision 1.4  1996/08/24 20:53:49  steve
 *  Add a self-test for i960.
 *
 * Revision 1.3  1996/08/08 05:22:47  steve
 *  Get rid of the __Scheduler class, it was not
 *  needed. Add the thread_runnable and _reschedule
 *  functions for thread scheduling.
 *
 * Revision 1.2  1996/05/29 23:58:50  steve
 *  Portable thread self tester.
 *
 * Revision 1.1  1995/10/06 00:07:51  steve
 *  support stack overflow checks.
 *
 */

# include  <ucr/ucr.h>
# include  <assert.h>
# include  "__thread.h"

#if defined(i960_cyclone)

void thread_self_test(THREAD*tid)
{
      unsigned long*fp = (unsigned long*)tid->bstack;

	// The very first frame has no previous frame, so the thread
	// creation code sets it to zero.
      assert( fp[0] == 0 );

	// The saved frame pointer must be in the stack.
      assert( tid->bstack <= (void*)tid->cookie.regs[15] );
      assert( (void*)tid->cookie.regs[15] < tid->estack );
}

#else

void thread_self_test(THREAD*)
{
      assert( ! uCR_thread_stack_check() );
}

#endif
