#
# Copyright (c) 1996 Picture Elements Inc.
#	Stephen Williams (steve@picturel.com)
#
#    This source code is free software; you can redistribute it
#    and/or modify it in source code form under the terms of the GNU
#    Library General Public License as published by the Free Software
#    Foundation; either version 2 of the License, or (at your option)
#    any later version. In order to redistribute the software in
#    binary form, you will need a Picture Elements Binary Software
#    License.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Library General Public License for more details.
#
#    You should have received a copy of the GNU Library General Public
#    License along with this program; if not, write to the
#    Free Software Foundation, Inc.,
#    59 Temple Place - Suite 330
#    Boston, MA 02111-1307, USA
#
#    You should also have recieved a copy of the Picture Elements
#    Binary Software License offer along with the source. This offer
#    allows you to obtain the right to redistribute the software in
#    binary (compiled) form. If you have not received it, contact
#    Picture Elements, Inc.,
#    777 Panoramic Way
#    Berkeley, CA 94704.
#
.ident "$Id: uCR_switch-i386.s,v 1.1 1996/11/09 04:34:27 steve Exp $"
#
# $Log: uCR_switch-i386.s,v $
# Revision 1.1  1996/11/09 04:34:27  steve
#  Add i386_linux thread infrastructure.
#
#
.file "uCR_switch-i386.s"

#
# The registers passed to me are those of the caller. They are the ones
# I must save in the cookie. The stack frame registers must go into the
# cookie so I can restore the stack when I switch back to this thread.
#
# I'm not too concerned about getting all the registers exactly right
# across thread switches because the switch goes through this function call
# which the compiler expects to trash some of the registers anyhow. On
# the other hand, I see no reason to be gratuitous about dashing registers
# so I will save most of them. When I optimize later (and figure out how
# to handle interrupts) I may decide to allow for more register scrap in
# order to save cycles.
#

	.set I386_REG_EAX, 0 * 4
	.set I386_REG_EDX, 1 * 4
	.set I386_REG_ECX, 2 * 4
	.set I386_REG_EBX, 3 * 4
	.set I386_REG_EBP, 4 * 4
	.set I386_REG_ESI, 5 * 4
	.set I386_REG_EDI, 6 * 4
	.set I386_REG_ESP, 7 * 4

# uCR_switch(ThreadCookie*to, ThreadCookie*self)

	.global	uCR_switch
uCR_switch:

  # Get the parameters off the stack. Golly, the i386 doesn't pass
  # parameters through registers? Shucks.

	movl	4(%esp), %eax
	movl	8(%esp), %edx

  # Save my registers into the self->regs area...

	movl	%eax, I386_REG_EAX(%edx)
	movl	%edx, I386_REG_EDX(%edx)
	movl	%ecx, I386_REG_ECX(%edx)
	movl	%ebx, I386_REG_EBX(%edx)
	movl	%ebp, I386_REG_EBP(%edx)
	movl	%esi, I386_REG_ESI(%edx)
	movl	%edi, I386_REG_EDI(%edx)
	movl	%esp, I386_REG_ESP(%edx)

  # Pull the other thread's registers in. Restore the %eax register
  # last because it is the pointer to where I'm getting the registers
  # from.

	movl	I386_REG_EDX(%eax), %edx
	movl	I386_REG_ECX(%eax), %ecx
	movl	I386_REG_EBX(%eax), %ebx
	movl	I386_REG_EBP(%eax), %ebp
	movl	I386_REG_ESI(%eax), %esi
	movl	I386_REG_EDI(%eax), %edi
	movl	I386_REG_ESP(%eax), %esp
	movl	I386_REG_EAX(%eax), %eax

	ret
