/*
 * Copyright (c) 1996 Picture Elements, Inc.
 *    Stephen Williams
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    Library General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc.,
 *    59 Temple Place - Suite 330
 *    Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc.,
 *    777 Panoramic Way
 *    Berkeley, CA 94704.
 */
#ident "$Id: tm-ucr960.h,v 1.2 1996/10/28 03:46:49 steve Exp $"
/*
 * $Log: tm-ucr960.h,v $
 * Revision 1.2  1996/10/28 03:46:49  steve
 *  License notice.
 *
 * Revision 1.1  1996/09/10 00:45:26  steve
 *  Add gdb interface to project.
 *
 */

# include  "i960/tm-i960.h"


#define	DEFAULT_PROMPT	"(uCR/i960) "


/* use fmark as the magic breakpoint instruction. */

#define BREAKPOINT {0x00, 0x3e, 0x00, 0x66}

/*
 * Amount ip must be decremented by after a breakpoint. uCR fixes up
 * the instruction pointer for us, so I do not need to adjust it at
 * all. Isn't that convenient?
 */

#define DECR_PC_AFTER_BREAK 0


/*
 * Use this function to pretty-print the thread ids that come out of
 * the target. uCR uses pointers to a struct THREAD, so this prints
 * the number in hex.
 */
#define target_pid_to_str(pid) ucr_target_pid_to_str(pid)
extern char*ucr_target_pid_to_str PARAMS((int pid));
