/*
 * Copyright (c) 1997 Picture Elements, Inc.
 *    Stephen Williams
 */
#ident "$Id: abortmsg.c,v 1.1 1997/06/15 20:07:31 steve Exp $"
/*
 * $Log: abortmsg.c,v $
 * Revision 1.1  1997/06/15 20:07:31  steve
 *  ISE assert that leave file/line info.
 *
 */

# include  <linux/module.h>
# include  <linux/bios32.h>
# include  <linux/pci.h>
# include  <asm/io.h>

const unsigned short vendor_id = 0x8086;
const unsigned short device_id = 0x1960;

int init_module(void)
{
      unsigned idx;

      for (idx = 0;; idx += 1) {
	    int rc;
	    unsigned char bus, dev_fn;
	    unsigned addr, ptr;

	    rc = pcibios_find_device(vendor_id, device_id, idx, &bus, &dev_fn);
	    if (rc != PCIBIOS_SUCCESSFUL) break;

	    rc = pcibios_read_config_dword(bus, dev_fn,
					   PCI_BASE_ADDRESS_0, &addr);
	    addr &= PCI_BASE_ADDRESS_MEM_MASK;

#if defined(__i386__)
	    ptr = (unsigned long)vremap(addr, 4096);
#else
	    ptr = addr;
#endif
	    if (readl(ptr+0x50) != 0xab0440ba) {
		  printk("ise%u: No abort cookie found.\n", idx);

	    } else {
		  static char buf[4096-0x58];
		  unsigned bp, sp;

		  for (bp = 0, sp = ptr + 0x58 ;  bp < sizeof buf ;
		       bp += 4, sp += 4)
			*(unsigned long*)(buf+bp) = readl(sp);

		  printk("ise%u: abort at ``%s:%u''\n", idx,
			 buf, readl(ptr+0x54));
	    }
      }

      return 0;
}

void cleanup_module(void)
{
}
