/*
 * Copyright (c) 1996 Picture Elements, Inc.
 *    Stephen Williams
 */
#ident "$Id: sprintf_test.cc,v 1.1 1996/11/10 23:38:54 steve Exp $"
/*
 * $Log: sprintf_test.cc,v $
 * Revision 1.1  1996/11/10 23:38:54  steve
 *  Add a regression test to uCR.
 *
 */

# include  <stdio.h>
# include  <string.h>
# include  <assert.h>

/*
 * This test is indended to exercise the formating capabilities of the
 * stdio library. It is generally the case that sprintf and printf
 * have common code for formatting, and that is certainly the case
 * with the uCR implementation. Therefore, a complete test of all the
 * formatting by using sprintf will convince me that it also works for
 * fprintf().
 */

void sprintf_test()
{
      char buffer[64];

      sprintf(buffer, "This is a test");
      assert( strcmp(buffer, "This is a test") == 0 );

      sprintf(buffer, "<%d> <%5d> <%-5d> <%.5d>", 15, 15, 15, 15);
      assert( strcmp(buffer, "<15> <   15> <15   > <00015>") == 0 );

      sprintf(buffer, "<%f>", 1.5);
      assert( strcmp(buffer, "<1.500000>") == 0 );
}
