#!/usr/bin/tclsh

# --
# Copyright (c) 1997 Picture Elements, Inc.
# Stephen Williams (steve@picturel.com)
#
# $Id: send.tcl,v 1.2 1998/03/23 19:56:09 steve Exp $

# This is an example of a script that uses the send_file subcommand of
# the tcl ucr interface extension. This command simply concatenates
# all the file names on the comand line into channel 0 of the ise
# board.

# To install, change the @libdir@ string to /usr/local/lib or whatever
# the name of the directory that contains the installed libucr.so file.
set libdir @libdir@

if {$tcl_platform(platform) == "windows"} {
    load ucr
    ucr_open ucr ise1 0
} else {
    load $libdir/libucr.so
    ucr_open ucr /dev/ise0 0
}

foreach file $argv {ucr send_file $file}


# $Log: send.tcl,v $
# Revision 1.2  1998/03/23 19:56:09  steve
#  Support for frames under NT,
#  and non-blocking I/O under tcl/nt
#
# Revision 1.1  1997/12/12 01:01:34  steve
#  Add the tclif interface to ucr channels.
#
