/*
 * Copyright (c) 1997 Picture Elements, Inc.
 *    Stephen Williams (steve@picturel.com)
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *  ---
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc., 777 Panoramic Way, Berkeley, CA 94704.
 */
#ident "$Id: isecons.c,v 1.1 1997/10/24 22:35:13 steve Exp $"

/*
 * This program reads from the ISE driver debug console any log
 * messages that may be stored there. It continues reading, waiting
 * for more messages to appear, until the program is killed.
 */

# include  <windows.h>
# include  <stdio.h>
# include  <io.h>

main()
{
      HANDLE ise;

      ise = CreateFile("\\\\.\\ISECONS", GENERIC_READ, 0, 0,
		       OPEN_EXISTING, FILE_FLAG_NO_BUFFERING, 0);
      if (ise == INVALID_HANDLE_VALUE) {
	    fprintf(stderr, "Failed to open ISE console.\n");
	    return 1;
      }

      for (;;) {
	    char buf[256];
	    DWORD cnt;
	    BOOL rc = ReadFile(ise, buf, sizeof buf, &cnt, 0);
	    if (!rc) {
		  fprintf(stderr, "Failed to read information.\n");
		  return 1;
	    }

	    buf[cnt] = 0;
	    printf("%s", buf);
      }

      CloseHandle(ise);
      return 0;
}

/*
 * $Log: isecons.c,v $
 * Revision 1.1  1997/10/24 22:35:13  steve
 *  Add NT utilities for manipulating ISE.
 *
 */

